Subject: bug#24315: 25.1.50; re-search-forward errors with "Variable binding depth exceeds max-specpdl-size"

From: [email-masked] (Peder O. Klingenberg)
Date: Fri, 02 Sep 2016 15:45:34 +0200

On Thu, Sep 01 2016 at 21:58, [email-masked] wrote:

>> -it finds."
>> +it finds. The current buffer should be an unfolded buffer as returned
>             ^
> Sentences should be double spaced.

Gah!  And I'm usually chided for using old-fashioned double spaces in
prose. :)

> Might be better to avoid finding the end of line twice (since apparently
> 40k lines do happen, I guess it's worth thinking a bit about
> optimizing):

Even finding the the end of the line twice was faster than the regexp
method, subjectively.  On my problematic 40k line, it did not take
noticable time, whereas the regexp caused a bit of a delay even on
shorter events.  But I agree, let's not make emacs do more work than
necessary.  Updated patch attached.

>From b51d09286492ae9be32b3718407174236db54059 Mon Sep 17 00:00:00 2001
From: "Peder O. Klingenberg" <[email-masked]>
Date: Tue, 30 Aug 2016 14:44:16 +0200
Subject: [PATCH] Avoid crash in icalendar--read-element

* lisp/calendar/icalendar.el (icalendar--read-element): Stop crashing
when parsing overly long event descriptions.  (Bug#24315)
---
 lisp/calendar/icalendar.el | 8 +++++---
 1 file changed, 5 insertions(+), 3 deletions(-)

diff --git a/lisp/calendar/icalendar.el b/lisp/calendar/icalendar.el
index 386c554..c88f4ab 100644
--- a/lisp/calendar/icalendar.el
+++ b/lisp/calendar/icalendar.el
@@ -361,7 +361,8 @@ icalendar--read-element
 INVALUE gives the current iCalendar element we are reading.
 INPARAMS gives the current parameters.....
 This function calls itself recursively for each nested calendar element
-it finds."
+it finds.  The current buffer should be an unfolded buffer as returned
+from `icalendar--get-unfolded-buffer'."
   (let (element children line name params param param-name param-value
                 value
                 (continue t))
@@ -391,8 +392,9 @@ icalendar--read-element
       (unless (looking-at ":")
         (error "Oops"))
       (forward-char 1)
-      (re-search-forward  "\\(.*\\)\\(\r?\n[ \t].*\\)*" nil t)
-      (setq value (icalendar--rris "\r?\n[ \t]" "" (match-string 0)))
+      (let ((start (point)))
+        (end-of-line)
+        (setq value (buffer-substring start (point))))
       (setq line (list name params value))
       (cond ((eq name 'BEGIN)
              (setq children
-- 
2.9.3